<?php
/*
 * این قسمت از پلاگین زیر اقتباس شده است :
 * https://wordpress.org/plugins/woocommerce-rtl/
 */

	add_action( 'admin_enqueue_scripts', 'persian_woocommerce_rtl_admin_styles', 11 );

	function persian_woocommerce_rtl_admin_styles() {
		if ( is_rtl() ) {
			
			$version = 2;
			if ( defined('WC_VERSION') )
				$version = 	WC_VERSION;
			else if ( defined('PERSIAN_WOOCOMMERCE_VERSION') )
				$version = 	PERSIAN_WOOCOMMERCE_VERSION;
			
			// menu.css
			wp_dequeue_style( 'woocommerce_admin_menu_styles' );
			wp_dequeue_style( 'woocommerce_admin_menu_styles_rtl' );
			wp_enqueue_style( 'woocommerce_admin_menu_styles_rtl', plugins_url('/assests/css/menu.css',__FILE__), array(), $version );

			$screen = get_current_screen();

			// admin.css

			if ( function_exists('wc_get_screen_ids') ) {
				if ( in_array( $screen->id, wc_get_screen_ids() ) ) {
					wp_dequeue_style( 'woocommerce_admin_styles' );
					wp_dequeue_style( 'woocommerce_admin_styles_rtl' );
					wp_enqueue_style( 'woocommerce_admin_styles_rtl', plugins_url('/assests/css/admin-woo.css',__FILE__), array(), $version );
					wp_enqueue_style( 'persian_woo_rtl_admin_styles', plugins_url('/assests/css/admin-ps.css',__FILE__), array(), $version );
				}
			}
			// dashboard.css
			if ( in_array( $screen->id, array( 'dashboard' ) ) ) {
				wp_dequeue_style( 'woocommerce_admin_dashboard_styles' );
				wp_dequeue_style( 'woocommerce_admin_dashboard_styles_rtl' );
				wp_enqueue_style( 'woocommerce_admin_dashboard_styles_rtl', plugins_url('/assests/css/dashboard.css',__FILE__), array(), $version );
			}

			// reports-print.css
			if ( in_array( $screen->id, array( 'woocommerce_page_wc-reports' ) ) ) {
				wp_dequeue_style( 'woocommerce_admin_dashboard_styles' );
				wp_dequeue_style( 'woocommerce_admin_print_reports_styles_rtl' );
				wp_enqueue_style( 'woocommerce_admin_print_reports_styles_rtl', plugins_url('/assests/css/reports-print.css',__FILE__), array(), $version, 'print' );
			}
		
		}
	}